# coding=utf_8

import pygame,res,glo,gui,string,cfg,mpl,fstruct
import glob,os

_stage = "none"
_name_sel = False
_name_val = cfg.get("player_name")
_ip_sel = False
_ip_val = cfg.get("server_ip")

_gamesel = []
_game_sel = None

_money_list = (1000,2000,4000,6000,10000)
_money = 1
_map_list = []
_map = 0
_map_data = None

_maps = glob.glob("data/*.map")
for m in _maps:
	name = os.path.basename(m)[:-4]
	_map_list.append(name)

glo.screen = pygame.display.set_mode((200,230))

def cresel(v=0):
	global _money,_map
	if v == "$+":
		_money+=1
		if _money >= len(_money_list):_money = 0
	if v == "$-":
		_money+=-1
		if _money < 0:_money = len(_money_list)-1
	
	if v == "ml":
		_map += -1
		if _map == -1:_map = len(_map_list)-1
		read_map_info()
	if v == "mr":
		_map += 1
		if _map >= len(_map_list):_map = 0
		read_map_info()

def read_map_info():
	global _map_data
	m = _map_list[_map]
	_map_data = fstruct.decode(open("data/%s.map"%m,"rb").read())

def create_game_menu(v=0):
	global _stage
	cfg.setval("player_name",_name_val)
	read_map_info()
	gui.hide_button("menu_create")
	gui.hide_button("menu_search")
	gui.hide_button("menu_join")
	_stage = "create"
	gui.show_button("menu_host")
	gui.show_button("create_mapl")
	gui.show_button("create_mapr")
	gui.show_button("create_mol")
	gui.show_button("create_mor")


def host_game_menu(v=0):
	global running,_stage
	m = _map_list[_map]
	glo.map_money = _money_list[_money]
	glo.map_file = "data/%s.map"%m
	gui.hide_button("menu_host")
	gui.hide_button("create_mapl")
	gui.hide_button("create_mapr")
	gui.hide_button("create_mol")
	gui.hide_button("create_mor")
	gui.show_button("menu_start")
	_stage = "lobby"
	mpl.start_server()
	mpl.mpl.netw.name = cfg.get("player_name")+"'s game"
	#running = False
	
def join_game_menu(v=0):
	global running,_stage
	cfg.setval("player_name",_name_val)
	cfg.setval("server_ip",_ip_val)
	cfg.save()
	mpl.start_client()
	gui.hide_button("menu_create")
	gui.hide_button("menu_search")
	gui.hide_button("menu_join")
	_stage = "lobby"
	#running = False

def sjoin_game_menu(v=0):
	global running,_stage
	if _game_sel:
		cfg.setval("player_name",_name_val)
		cfg.save()
		mpl.mpl.netw.close()
		mpl.start_client(_game_sel)
		gui.hide_button("menu_create")
		gui.hide_button("menu_search")
		gui.hide_button("menu_join")
		_stage = "lobby"

def search_game_menu(v=0):
	global running,_stage
	cfg.setval("player_name",_name_val)
	cfg.save()
	gui.hide_button("menu_create")
	gui.hide_button("menu_search")
	gui.hide_button("menu_join")
	gui.show_button("menu_sjoin")
	_stage = "search"
	mpl.start_searching()

def start_game(v=0):
	mpl.netSend(("START",glo.lobby_clients))
	mpl.mpl.netw.accepting = False
	mpl.mpl.netw.broadcasting = False
	glo.player_id = 0

def select_game(v=0):
	global _game_sel
	_game_sel = v

gui.add_button("menu_join",join_game_menu,(20,130),(160,20),"")
gui.add_button("menu_search",search_game_menu,(20,160),(160,20),"")
gui.add_button("menu_create",create_game_menu,(20,190),(160,20),"")

gui.add_button("menu_start",start_game,(20,190),(160,20),"",False)
gui.add_button("menu_sjoin",sjoin_game_menu,(20,190),(160,20),"",False)

gui.add_button("menu_host",host_game_menu,(20,190),(160,20),"",False)
gui.add_button("create_mapl",cresel,(130,160),(20,20),"ml",False)
gui.add_button("create_mapr",cresel,(160,160),(20,20),"mr",False)
gui.add_button("create_mol",cresel,(130,139),(20,11),"$-",False)
gui.add_button("create_mor",cresel,(160,139),(20,11),"$+",False)

def paint():
	global running,_gamesel
	if glo.game_started:
		running = False
		return
	if _stage == "none":
		glo.screen.blit(res.cache.get("menu"),(0,0))
		glo.screen.blit(res.cache.get("menu_over"),(0,0))
		gui.paint_button("menu_create")
		gui.paint_button("menu_search")
		gui.paint_button("menu_join")
		q = _name_sel and "f" or "n"
		glo.screen.blit(res.cache.get("input_%s"%q),(20,60))
		glo.screen.blit(gui.renderString(_name_val,12,(255,255,255)),(30,63))
		q = _ip_sel and "f" or "n"
		glo.screen.blit(res.cache.get("input_%s"%q),(20,100))
		glo.screen.blit(gui.renderString(_ip_val,12,(255,255,255)),(30,103))
	if _stage == "lobby":
		glo.screen.blit(res.cache.get("menu_lobby"),(0,0))
		glo.screen.blit(res.cache.get("menu_over"),(0,0))
		plc = res.cache.get("player_colors")
		y = 0
		index = 0
		for c,a in glo.lobby_clients:
			_a = False
			if a != -1:_a = "%s:%s"%a
			cl = (255,255,255)
			if _a == mpl.mpl.addr:cl = (0,255,0)
			srf = gui.renderString(c,12,cl)
			glo.screen.blit(srf,(43,47+y))
			glo.screen.blit(plc,(30,47+y),( 0, index*10,10,10 ))
			y += 15
			index += 1
		gui.paint_button("menu_start")
	if _stage == "search":
		glo.screen.blit(res.cache.get("menu_search"),(0,0))
		glo.screen.blit(res.cache.get("menu_over"),(0,0))
		gui.paint_button("menu_sjoin")
		y = 0
		_gamesel = []
		for d in glo.lobby_games:
			data,addr = glo.lobby_games[d]
			name = data[0]
			cl = (255,255,255)
			if _game_sel == addr[0]:cl = (0,255,0)
			srf = gui.renderString(name,12,cl)
			glo.screen.blit(srf,(35,47+y))
			_gamesel.append(( 35,47+y,160,15,select_game,addr[0] ))
			y += 15
	if _stage == "create":
		glo.screen.blit(res.cache.get("menu_create"),(0,0))
		glo.screen.blit(res.cache.get("menu_over"),(0,0))
		gui.paint_button("create_mapl")
		gui.paint_button("create_mapr")
		gui.paint_button("create_mol")
		gui.paint_button("create_mor")
		gui.paint_button("menu_host")
		txt = "$ %s"%( _money_list[_money] )
		glo.screen.blit(gui.renderString(txt,12,(255,255,255)),(133,123))
		txt = "%s"%_map_data['players']
		glo.screen.blit(gui.renderString(txt,12,(255,255,255)),(154,64))
		txt = "%sx%s"%_map_data['size']
		glo.screen.blit(gui.renderString(txt,12,(255,255,255)),(136,94))
		txt = _map_data['name']
		glo.screen.blit(gui.renderString(txt,12,(255,255,255)),(23,163))
		glo.screen.blit(_map_data['minimap'],(20,50))
	
	if glo.messages:
		glo.screen.fill((0,0,0))
		txt = gui.renderString("Error",16,(255,0,0))
		glo.screen.blit(txt,(10,10))
		y = 0
		for st in glo.messages:
			txt = gui.renderString(str(st),12,(255,0,0))
			x = (200-txt.get_width())/2
			glo.screen.blit(txt,(x,y+30))
			y += 14
	
	pygame.display.flip()
	

def click():
	global _name_sel,_ip_sel,_gamesel
	p = pygame.mouse.get_pos()
	for x,y,w,h,f,a in _gamesel:
		if x<=p[0]<=x+w and y<=p[1]<=y+h:
			f(a)
			return False

	if gui.check_mouse_click(p):return False
	if 20<=p[0]<=180 and 60<=p[1]<=80:
		_name_sel = True
	else:
		_name_sel = False
		
	if 20<=p[0]<=180 and 100<=p[1]<=120:
		_ip_sel = True
	else:
		_ip_sel = False
	
def mousemove():
	p = pygame.mouse.get_pos()
	gui.check_mouse_move(p)
	
def keydown(e):
	global _name_val,_ip_val
	k = e.key
	ch = e.unicode
	if _name_sel:
		if len(_name_val) <= 10:
			if k == 32:_name_val+=" "
			if ch in string.ascii_letters or ch in string.digits:
				_name_val+= ch
		if k == 8:
			_name_val = _name_val[:-1]
		if k == 127:
			_name_val = ""
	if _ip_sel:
		print ch
		if len(_ip_val) < 15:
			if ch in ("."," ",",","-"):_ip_val+="."
			if ch in string.digits:
				_ip_val+= ch
		if k == 8:
			_ip_val = _ip_val[:-1]
		if k == 127:
			_ip_val = ""

clock = pygame.time.Clock()
clock_tick = clock.tick
pygevget = pygame.event.get
running = True
while running:
	tremains = clock_tick(40)
	evts = pygevget()
	for event in evts:
		if event.type == pygame.NOEVENT:break
		elif event.type == pygame.QUIT:
			running = False
			raise SystemExit
		elif event.type == pygame.MOUSEBUTTONDOWN:
			click()
		elif event.type == pygame.MOUSEMOTION:
			mousemove()
		elif event.type == pygame.KEYDOWN:
			keydown(event)
	if _stage in ("lobby","search"):mpl.mpl.tick()
	paint()

