import glo,unit,mpl
build = ["harvester","fav1","fav2","daemon","mct","mrt","bigshit","@confuse","@storm"]
abilites = {}

def ability_storm(player):
	glo.add_effect("storm",20)
	for u in glo.units:
		if u.base:continue
		u.harm(False,u.hp/2)

def ability_confuse(player):
	if glo.iam.player_id != player:
		glo.add_effect("confuse",340)

abilites["storm"] = {
	"name": "Storm",
	"desc": "Large damage to each unit on map",
	"price": 3000,
	"func": ability_storm,
	"count": 2,
}

abilites["confuse"] = {
	"name": "Confuse",
	"desc": "Confuse oponents",
	"price": 2000,
	"func": ability_confuse,
	"count": 3,
}

units = {}

units["harvester"] = {
	'name': 'Harvester',
	'desc': 'Money maker.',
	'image': 'unit_harvester',
	'class': ('light',),
	'price': 300,
	'explo': 1,
	'hp': 400,
	'speed': 7,
	'fire_rate': 0,
	'range': 100,
	'damage': 0,
	'damage_type': 'none',
	'repair': 0.02,
	'defense': 0,
	'trans_turret': 0,
	'money_grab': 0.75
}

#### TANKS
units["fav1"] = {
	'name': 'FAV1R',
	'desc': 'Fast assault vehicle - rocket.',
	'image': 'unit3',
	'class': ('light','rocket'),
	'price': 400,
	'explo': 1,
	'hp': 100,
	'speed': 8,
	'fire_rate': 22,
	'range': 320,
	'damage': 12,
	'damage_type': 'rocket',
	'rocket_speed': 16,
	'rocket_image': 'rocket1',
	'rocket_def': [5,-5],
	'rocket_random': [-2,2],
	'repair': 0.01,
	'defense': 0,
	'trans_turret': -10,
	'money_grab': 0
}

units["fav2"] = {
	'name': 'FAV2C',
	'desc': 'Fast assault vehicle - cannon.',
	'image': 'unit1',
	'class': ('light','slug'),
	'price': 450,
	'explo': 1,
	'hp': 100,
	'speed': 8,
	'fire_rate': 22,
	'range': 310,
	'damage': 8,
	'damage_type': 'slug',
	'repair': 0.01,
	'defense': 0,
	'trans_turret': -10,
	'money_grab': 0
}

units["daemon"] = {
	'name': 'Daemon',
	'desc': 'Heavy and strong. Equipped with two cannons.',
	'image': 'unit2',
	'class': ('heavy','tank','slug'),
	'price': 700,
	'explo': 2,
	'hp': 350,
	'speed': 6,
	'fire_rate': 27,
	'range': 260,
	'damage': 19,
	'damage_type': 'slug',
	'repair': 0.05,
	'defense': 1,
	'trans_turret': 0,
	'money_grab': 0
}

units["bigshit"] = {
	'name': 'Big Shit',
	'desc': 'Rocket swarm attack.',
	'image': 'unit_mamba',
	'class': ('heavy','rocket'),
	'price': 5000,
	'explo': 3,
	'hp': 400,
	'speed': 3.9,
	'fire_rate': 27,
	'range': 300,
	'damage': 22,
	'damage_type': 'rocket',
	'rocket_speed': 9,
	'rocket_image': 'rocket2',
	'rocket_def': [-20,-21,-22,20,21,22],
	'rocket_random': [2,6,10,-2,-6,-10],
	'repair': 0.05,
	'defense': 0,
	'trans_turret': -16,
	'money_grab': 0
}


#### TOWERS
units["mct"] = {
	'name': 'Mobile Cannon Tower',
	'desc': 'Slow builder',
	'image': 'unit_mrt',
	'class': ('heavy',),
	'transform': "cannon_tower",
	'price': 2700,
	'explo': 2,
	'hp': 450,
	'speed': 3,
	'fire_rate': 200,
	'range': 60,
	'damage': 0,
	'damage_type': 'none',
	'repair': 0.05,
	'defense': 2,
	'trans_turret': 0,
	'money_grab': 0
}

units["cannon_tower"] = {
	'name': 'Cannon tower',
	'desc': '',
	'image': 'tower1',
	'class': ('tower','slug'),
	'price': 0,
	'explo': 3,
	'hp': 650,
	'speed': 0,
	'fire_rate': 10,
	'range': 380,
	'damage': 15,
	'damage_type': 'slug',
	'repair': 0.05,
	'defense': 2,
	'trans_turret': 0,
	'money_grab': 0
}

units["mrt"] = {
	'name': 'Mobile Rocket Tower',
	'desc': 'Slow builder',
	'image': 'unit_mrt',
	'class': ('heavy',),
	'transform': "rocket_tower",
	'price': 2500,
	'explo': 2,
	'hp': 450,
	'speed': 3,
	'fire_rate': 200,
	'range': 60,
	'damage': 0,
	'damage_type': 'none',
	'repair': 0.05,
	'defense': 2,
	'trans_turret': 0,
	'money_grab': 0
}

units["rocket_tower"] = {
	'name': 'Rocket tower',
	'desc': '',
	'image': 'tower2',
	'class': ('tower','rocket'),
	'price': 0,
	'explo': 3,
	'hp': 600,
	'speed': 0,
	'fire_rate': 12,
	'range': 420,
	'damage': 12,
	'damage_type': 'rocket',
	'rocket_speed': 18,
	'rocket_image': 'rocket2',
	'rocket_def': [16,-16],
	'rocket_random': [2,-2],
	'repair': 0.05,
	'defense': 2,
	'trans_turret': 0,
	'money_grab': 0
}

