# coding=utf_8

import math

def pos_in_view(p1,p2,s):
	if p2[0]<=p1[0]<=p2[0]+s[0] and p2[1]<=p1[1]<=p2[1]+s[1]:
		return True
	return False

def avg_coords_by_mid(arr):
	_indexes = []
	_avg = [0,0]
	for x,y in arr:
		_avg[0] += x
		_avg[1] += y
	_avg = ( _avg[0]/float(len(arr)), _avg[1]/float(len(arr)) )
	index = 0
	_adist = 1000000
	for x,y in arr:
		dist = math.hypot(x-_avg[0],y-_avg[1])
		if dist <= _adist:
			_indexes.insert(0,index)
			_adist = dist
		else:
			_indexes.append(index)
		index += 1
	return _indexes,_avg

def translated_coords(pos,rel):
	return ( pos[0]+rel[0], pos[1]+rel[1] )

def get_direction(p1,p2):
	ax,ay = p1
	tx,ty = p2
	x = tx - float(ax)
	y = ty - float(ay)
	return math.atan2(x, y)
	
def get_distance(p1,p2):
	ax,ay = p1
	tx,ty = p2
	x = tx - float(ax)
	y = ty - float(ay)
	return math.hypot(x,y)




